Public Class ExtractShapes
    Dim xl As Excel.Application = Nothing
    Dim main_wb As Excel.Workbook = Nothing

    Public Function ungroup(ByVal wb As Excel.Workbook) As Boolean

        Dim sh As Excel.Shape
        Dim ws As Excel.Worksheet

        For Each ws In wb.Worksheets
            For Each sh In ws.Shapes
                If sh.Type = Office.MsoShapeType.msoShapeTypeMixed Then
                    sh.Ungroup()
                End If
            Next
        Next

        Return True
    End Function

    Public Function run(ByVal in_src As String, ByVal in_dest As String) As Boolean

        Dim wb As Excel.Workbook
        Dim na As String
        Dim cnt As Long

        If (xl Is Nothing) Then
            xl = New Excel.Application
        End If
        If (main_wb Is Nothing) Then
            main_wb = xl.Workbooks.Add()
        End If

        na = in_src

        wb = xl.Workbooks.Open(na, , True)
        wb.Activate()

        Dim ffn As String = System.IO.Path.GetFileName(in_src)

        Try
            ungroup(wb)

            Dim sh As Excel.Shape
            Dim ws As Excel.Worksheet

            cnt = 0

            For Each ws In wb.Worksheets

                For Each sh In ws.Shapes
                    cnt = cnt + 1

                    Debug.Print(sh.Name, sh.Width, sh.Height)
                    sh.Copy()

                    Dim aw As Excel.Worksheet
                    aw = main_wb.ActiveSheet

                    Dim obj As Excel.ChartObject
                    obj = aw.ChartObjects.Add(0, 0, sh.Width, sh.Height)

                    obj.Activate()

                    main_wb.ActiveChart.Paste()

                    Dim fn As String = in_dest & "\" & ffn & "_" & System.Guid.NewGuid.ToString & ".jpg"

                    Call main_wb.ActiveChart.Export(fn, "JPG", False)

                Next
            Next

        Catch ex As Exception

            System.Console.WriteLine(ex.Message)

        Finally

            wb.Saved = True
            wb.Close(False)

        End Try

        Return True

    End Function

    Public Sub New()
    End Sub

    Public Sub purge()
        If Not (xl Is Nothing) Then
            For Each x As Excel.Workbook In xl.Workbooks
                x.Saved = True
            Next
            xl.Workbooks.Close()
            xl.Quit()
            xl = Nothing
        End If
    End Sub

End Class
