Imports System.IO

Module Module1

    Sub Main()

        Debug.Listeners.Add(New TextWriterTraceListener(Console.Out))

        If Not (System.Environment.GetCommandLineArgs().Length = 3) Then
            Debug.WriteLine("Usage:pg src_folder dest_folder")
            Exit Sub
        End If

        Dim md5 As New System.Security.Cryptography.MD5CryptoServiceProvider

        Dim in_src = System.Environment.GetCommandLineArgs(1)
        Dim in_out = System.Environment.GetCommandLineArgs(2)
        Debug.Print(in_src, in_out)

        If Not RecursiveSearch.run(in_src, in_out) Then
            Debug.WriteLine("abort.end")
            Exit Sub
        End If

        Dim ext As New ExtractShapes
        Try
            For Each src_file As String In Directory.GetFiles(in_src, "*.xls", SearchOption.AllDirectories)
                Dim dest_file As String = UCase(src_file).Replace(UCase(in_src), UCase(in_out))
                Dim dest_folder As String = Path.GetDirectoryName(dest_file)



                ext.run(src_file, dest_folder)

                Dim fs As FileStream = New FileStream(src_file, FileMode.Open, FileAccess.Read)
                Try
                    Dim bs As Byte() = md5.ComputeHash(fs)


                    Dim fn As String = Path.GetFileName(src_file)

                    Dim strb As New System.Text.StringBuilder
                    For Each b As Byte In bs
                        strb.Append(b.ToString("x2"))
                    Next

                    Dim z As Ionic.Zip.ZipFile = New Ionic.Zip.ZipFile(dest_folder & "\" & fn & ".zip")
                    z.AddFile(src_file)
                    z.ZipErrorAction = Ionic.Zip.ZipErrorAction.Skip
                    z.CompressionLevel = Ionic.Zlib.CompressionLevel.BestCompression
                    z.Save()
                    z = Nothing

                    Dim md5f As String = dest_folder & "\" & "md5.sum"

                    If Not System.IO.File.Exists(md5f) Then
                        With New StreamWriter(md5f, False)
                            .Close()
                        End With

                    End If
                    With New StreamWriter(md5f, True)
                        .WriteLine(strb.ToString & " " & fn)
                        .Close()
                    End With

                Catch ex2 As Exception

                    Debug.WriteLine(ex2.Message)

                Finally
                    fs.Close()
                End Try

            Next

        Catch ex As Exception
            Debug.WriteLine(ex.Message)
        Finally
            ext.purge()
        End Try



    End Sub

End Module
